/*
 * communication_protocol.h
 *
 *  Created on: 2024518
 *      Author: 34509
 */

#ifndef SOFTWARE_PROTOCOL_COMMUNICATION_PROTOCOL_H_
#define SOFTWARE_PROTOCOL_COMMUNICATION_PROTOCOL_H_

#include "inc/UART.h"
#include "uart_dev.h"


/*  */
typedef enum
{
   SL_Function_Code_Read_Register           =   0x30,  /* Ĵ */
   SL_Function_Code_Write_Register          =   0x10,  /* дĴ */
   SL_Function_Code_Broadcast_Scan          =   0xA0,  /* 㲥ɨ */
   SL_Function_Code_Registration_request    =   0xA1,  /* ע */
}SL_MsgFunctionCode;

/* Ĵַ */
typedef enum
{
   SL_Register_Registration_Status                      = 0x0000,   /* ע״̬  */
   SL_Register_address                                  = 0x0001,   /* ַ  */
   SL_Register_Access_Node_Type                         = 0x0002,   /* ڵ   */
   SL_Register_Communication_Methods                    = 0x0003,   /* ͨŷʽ   */

   SL_Register_Battery_Voltage                          = 0x0100,   /* صѹ   */
   SL_Register_Battery_temperature                      = 0x0101,   /* ¶   */
   SL_Register_Remaining_Battery_Bower                  = 0x0102,   /* ʣ   */
   SL_Register_Solar_Open_Circuit_Voltage1              = 0x0103,   /* ̫ܿ·ѹ1 */
   SL_Register_Solar_Open_Circuit_Voltage2              = 0x0104,   /* ̫ܿ·ѹ2 */

   SL_Register_Ambient_Temperature                      = 0x0200,   /* ¶ */
   SL_Register_Ambient_Humidity                         = 0x0201,   /* ʪ */
   SL_Register_Barometric_Pressure                      = 0x0202,   /* ѹ */
   SL_Register_Wind_Speed                               = 0x0203,   /*  */
   SL_Register_Wind_Direction                           = 0x0204,   /*  */
   SL_Register_Rainfall                                 = 0x0205,   /*  */
   SL_Register_Optical_Radiation                        = 0x0206,   /*  */

   SL_Register_Leakage_Current_Value                    = 0x0220,   /* й©ֵ */
   SL_Register_Leakage_Current_MaxValue                 = 0x0221,   /* й©ֵ */
   SL_Register_Pulse_Frequency                          = 0x0222,   /*  */
   SL_Register_Zero_Leakage_Current_MaxValue_Statistics = 0x0223,   /* й©ֵͳ */
   SL_Register_Zero_Pulse_Frequency_Statistics          = 0x0224,   /* ͳ */

   SL_Register_Inclination_AngleX                       = 0x0230,   /* X */
   SL_Register_Inclination_AngleY                       = 0x0231,   /* Y */
   SL_Register_Zero_Inclination_Angle                   = 0x0232,   /* У */
}SL_MsgRegister;

/* ע״̬ */
typedef enum
{
   UNREGISTER = 0,          /* δע */
   REGISTER_FAIL = 1,       /* עʧ */
   REGISTER_SUCCESS = 2,    /* עɹ */
}SL_REGISTERSTATUS;

/* ڵ */
typedef enum
{
   POWERBOX = 1,            /* Դ */
   MICROMETEOROLOGY = 2,    /* ΢ */
}SL_ACCESSNODETYPE;

/* ͨŷʽ */
typedef enum
{
    RS485 = 1,
    RJ45 = 2,
}SL_COMMUNICATIONMETHODS;

/* ָ뷽ʽΪ1ֽ */
#pragma pack(push,1)

/* ʱ͵֡ʽ->ڵ㣩 */
typedef struct _SL_Mppt_Rorecv_pack{
    uint8_t start_Flag[2];                  /* ʼ־  */
    uint8_t address[7];                     /* ַ */
    uint8_t function_Code;                  /*  */
    uint8_t read_Register_Start_Address_H;  /* ȡĴʼַ8λ */
    uint8_t read_Register_Start_Address_L;  /* ȡĴʼַͰλ */
    uint8_t read_Register_Number_H;         /* ȡĴ߰λ */
    uint8_t read_Register_Number_L;         /* ȡĴͰλ */
    uint8_t check_Bit_H;                    /* Уλ߰λ */
    uint8_t check_Bit_L;                    /* УλͰλ */
    uint8_t end_Flag;                       /* ־ */
}SL_Mppt_Rorecv_pack;
#define SL_MPPT_RORECV_PACK_SIZE        (sizeof(SL_Mppt_Rorecv_pack))

/* ʱյĻظ֡ʽڵ->أ */
typedef struct _SL_Mppt_ROReply_pack{
    uint8_t start_Flag[2];                  /* ʼ־  */
    uint8_t address[7];                     /* ַ */
    uint8_t function_Code;                  /*  */
    uint8_t reply_Register_Number_H;        /* ظֽȸ߰λ  */
    uint8_t reply_Register_Number_L;        /* ظֽȵͰλ  */
    uint8_t *content;                       /* ظ */
    uint8_t check_Bit_H;                    /* Уλ߰λ */
    uint8_t check_Bit_L;                    /* УλͰλ */
    uint8_t end_Flag;                       /* ־ */
}SL_Mppt_ROReply_pack;
#define SL_MPPT_ROReply_PACK_SIZE        (sizeof(SL_Mppt_ROReply_pack))

/* ɨ㲥֡F1->ڵ㣩 */
typedef struct _SL_Mppt_ScanBroadcast_pack{
    uint8_t start_Flag[2];                  /* ʼ־  */
    uint8_t address[7];                     /* ַ */
    uint8_t function_Code;                  /*  */
    uint8_t check_Bit_H;                    /* Уλ߰λ */
    uint8_t check_Bit_L;                    /* УλͰλ */
    uint8_t end_Flag;                       /* ־ */
}SL_Mppt_Scan_Broadcast_pack;
#define SL_MPPT_SCAN_BROADCAST_PACK_SIZE    (sizeof(SL_Mppt_Scan_Broadcast_pack))

/* ע֡F2ڵ->أ */
typedef struct _SL_Mppt_RegistrationRequest_pack{
    uint8_t start_Flag[2];              /* ʼ־  */
    uint8_t address[7];                 /* ַ */
    uint8_t function_Code;              /*  */
    uint8_t register_Length_H;          /* Ĵȸ߰λ */
    uint8_t register_Length_L;          /* ĴȵͰλ */
    uint8_t registration_Status_H;      /* ע״̬߰λ  */
    uint8_t registration_Status_L;      /* ע״̬Ͱλ */
    uint8_t access_Node_ID[7];          /* ڵID */
    uint8_t access_Node_Type_H;         /* ڵ͸߰λ */
    uint8_t access_Node_Type_L;         /* ڵ͵Ͱλ */
    uint8_t check_Bit_H;                /* Уλ߰λ */
    uint8_t check_Bit_L;                /* УλͰλ */
    uint8_t end_Flag;                   /* ־ */
}SL_Mppt_RegistrationRequest_pack;
#define SL_MPPT_REGISTRATIONREQUEST_PACK_SIZE    (sizeof(SL_Mppt_RegistrationRequest_pack))

/* עظ֡F3->ڵ㣩 */
typedef struct _SL_Mppt_RegistrationReply_pack{
    uint8_t start_Flag[2];              /* ʼ־  */
    uint8_t address[7];                 /* ַ */
    uint8_t function_Code;              /*  */
    uint8_t register_Length_H;          /* Ĵȸ߰λ */
    uint8_t register_Length_L;          /* ĴȵͰλ */
    uint8_t registration_Status_H;      /* ע״̬߰λ  */
    uint8_t registration_Status_L;      /* ע״̬Ͱλ */
    uint8_t check_Bit_H;                /* Уλ߰λ */
    uint8_t check_Bit_L;                /* УλͰλ */
    uint8_t end_Flag;                   /* ־ */
}SL_Mppt_RegistrationReply_pack;
#define SL_MPPT_REGISTRATIONREPLY_PACK_SIZE (sizeof(SL_Mppt_RegistrationReply_pack))

/*  */
#define RECV_LENGTH 20
typedef struct _SL_Mppt_Recv_pack{
    uint8_t  start_Flag[2];                 /* ʼ־  */
    uint8_t  address[7];                    /* ַ */
    uint8_t  function_Code;                 /*  */
    uint8_t  recv_Data[RECV_LENGTH];        /*  */
}SL_Mppt_Recv_pack;

/* 봦 */
typedef void (*MsgProcFunc)(device_handle device, void*, uint32_t MsgLen);
typedef struct _SL_FunctionMsgProcTable{
    u_int32_t    msgId;
    MsgProcFunc  pMsgProc;
}SL_FuncionMsgProcTable;

/* ָĬϵĶ */
#pragma pack(pop)

extern SL_Mppt_Scan_Broadcast_pack g_Scan_Broadcast_pack;

void read_and_process_uart_data(device_handle device);
void send_data(uint8_t *buff);

#endif /* SOFTWARE_PROTOCOL_COMMUNICATION_PROTOCOL_H_ */
